org.apache.struts2.portlet.dispatcher

## Class DirectRenderFromEventAction

- java.lang.Object
- - org.apache.struts2.portlet.dispatcher.DirectRenderFromEventAction

- All Implemented Interfaces:
    Serializable, Action, SessionAware

      public class DirectRenderFromEventAction
      extends Object
      implements SessionAware, Action, Serializable

  When a portlet is targetted for an `event`, the portlet will receive two portlet requests, one for the `event` phase, and then followed by a `render` operation. When in the `event` phase, the action that is executed can't render any output. This means that if an action in the XWork configuration is executed in the event phase, and the action is set up with a result that should render something, the result can't immediately be executed. The portlet needs to "wait" to the render phase to do the rendering.

  When the `PortletResult` detects such a scenario, instead of executing the actual view, it prepares a couple of render parameters specifying this action and the location of the view, which then will be executed in the following render request.

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from interface org.apache.struts2.action.Action

      `ERROR, INPUT, LOGIN, NONE, SUCCESS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DirectRenderFromEventAction()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `execute()` Always return success.
    `String` | `getLocation()` Get the location of the view.
    `void` | `withSession(Map<String,Object> session)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DirectRenderFromEventAction

          public DirectRenderFromEventAction()

  - ### Method Detail

    - #### getLocation

          public String getLocation()

      Get the location of the view.
      Returns:
        Returns the location.

    - #### execute

          public String execute()
                         throws Exception

      Always return success.
      Specified by:
        `execute` in interface `Action`
      Returns:
        SUCCESS
      Throws:
        `Exception`

    - #### withSession

          public void withSession(Map<String,Object> session)

      Specified by:
        `withSession` in interface `SessionAware`

Copyright © 2000–2025 Apache Software Foundation. All rights reserved.